'   Programm fr drei Richtungen
' Vorlage-Datei fr Attiny-Platine von E. Eube, G. Heinrichs und U. Ihlefeldt
'----------------------------------------------------------------------------

$regfile = "attiny2313.dat"
$crystal = 4000000
$baud = 9600

Config Scl = Portb.7
Config Sda = Portb.5


'**********************************************************
'******************* Deklarationen ************************

Declare Sub Writei2c(byval Register As Byte , Byval Wert As Byte)
Declare Sub Beschleunigung_lesen(byval Reh As Byte , Byval Rel As Byte)
Declare Function Readi2c(byval Register As Byte)as Byte



Const Adresse = &HD0
Const Adresse2 = &HD1
Const Resleep = &H6B
Const Rexh = &H3B
Const Rexl = &H3C
Const Reyh = &H3D
Const Reyl = &H3E
Const Rezh = &H3F
Const Rezl = &H40

'****************** Initialisierung ***********************

Ddrb = &B11111111
Ddrd = &B01110000
Portd = &B10001111

Waitms 3000


'**********************************************************
'******************** Hauptprogramm ***********************


  Call Writei2c(resleep , 0)
  Do
    Call Beschleunigung_lesen(rexh , Rexl)
    Call Beschleunigung_lesen(reyh , Reyl)
    Call Beschleunigung_lesen(rezh , Rezl)
    Print ""
    Waitms 50
  Loop



'**********************************************************
'******************* Unterprogramme ***********************

  Sub Writei2c(byval Register As Byte , Byval Wert As Byte)
    I2cstart
    I2cwbyte Adresse
    If Err = 0 Then
       I2cwbyte Register
       I2cwbyte Wert
     Else
       Print ; Wert ; "-" ; Register
    End If
    I2cstop
  End Sub


  Function Readi2c(byval Register As Byte) As Byte
    I2cstart
    I2cwbyte Adresse
    If Err = 0 Then
       I2cwbyte Register
       I2cstart
       I2cwbyte Adresse2
       I2crbyte Readi2c , Nack
     Else
        Print "E" ; Register
    End If
    I2cstop
  End Function


  Sub Beschleunigung_lesen(reh As Bythe , Rel As Byte)
  Dim H As Byte
  Dim L As Byte
  Dim Tempi As Integer
  Dim Tempsi As Single
    H = Readi2c(reh)
    L = Readi2c(rel)
    Tempi = 256 * H
    Tempi = Tempi + L
    Tempsi = Tempi * 0.00059875
    Print Tempsi ; "m/s2" ; ";";
  End Sub

'**********************************************************
'******************Interruptroutinen***********************